import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ThinkInvoiceConfig, ThinkInvoiceConfigParam } from './model';
import { THINK_API_URL } from '@/config/setting';

/**
 * 分页查询
 */
export async function pageThinkInvoiceConfig(params: ThinkInvoiceConfigParam) {
  const res = await request.get<ApiResult<PageResult<ThinkInvoiceConfig>>>(
    THINK_API_URL + '/think/think-invoice-config/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询列表
 */
export async function listThinkInvoiceConfig(params?: ThinkInvoiceConfigParam) {
  const res = await request.get<ApiResult<ThinkInvoiceConfig[]>>(
    THINK_API_URL + '/think/think-invoice-config',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加
 */
export async function addThinkInvoiceConfig(data: ThinkInvoiceConfig) {
  const res = await request.post<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-invoice-config',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改
 */
export async function updateThinkInvoiceConfig(data: ThinkInvoiceConfig) {
  const res = await request.put<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-invoice-config',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除
 */
export async function removeThinkInvoiceConfig(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-invoice-config/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除
 */
export async function removeBatchThinkInvoiceConfig(
  data: (number | undefined)[]
) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-invoice-config/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询
 */
export async function getThinkInvoiceConfig(id: number) {
  const res = await request.get<ApiResult<ThinkInvoiceConfig>>(
    THINK_API_URL + '/think/think-invoice-config/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
